﻿--Bar creation module

local width, height = 300, 24

function SN:SNCreateBG(frame)
	if(IsAddOnLoaded("ElvUI")) then
		local bg = CreateFrame("Frame")
		bg:SetTemplate("Default")
		bg:SetParent(frame)
		bg:ClearAllPoints()
		bg:Point("TOPLEFT", frame, "TOPLEFT", -2, 2)
		bg:Point("BOTTOMRIGHT", frame, "BOTTOMRIGHT", 2, -2)
		bg:SetFrameStrata("LOW")
		bg:Show()
	end
end

function SN:CreateBar(group, cooldown, duration, caster, guid, spell)
	local v = SN.Media
	local class, classFileName, classID = UnitClass(caster)
	local bar
	--Start the CD Timer
	if (IsAddOnLoaded("ElvUI")) then
		if group == SN.F.debuffs then
			bar = SN.timers:NewBar(nil, width, height - 4, v.media.minTex)
		else
			bar = SN.timers:NewBar(nil, width, height, v.media.minTex)
		end
		SN:SNCreateBG(bar)
	else
		if group == SN.F.debuffs then
			bar = SN.timers:NewBar(nil, width, height, v.media.minTex)
		else
			bar = SN.timers:NewBar(nil, width, height + 8, v.media.minTex)
		end
		bar:SetAlpha(1)
		bar:SetBackdrop({
		bgFile = v.media.blankTex, 
		edgeFile = v.media.blankTex, 
		tile = false, tileSize = 0, edgeSize = 2, 
		insets = { left = -2, right = 2, top = 2, bottom = -2 }
		})
		bar:SetBackdropColor(0, 0, 0, 0)
		bar:SetBackdropBorderColor(0.1, 0.1, 0.1, 1)
	end
	
	bar:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

	bar:SetData("SN:arg1", group)
	bar:SetData("SN:arg2", cooldown)
	bar:SetData("SN:arg3", guid)
	bar:SetData("SN:arg4", caster)
	bar:SetData("SN:arg5", spell)
	bar:SetData("SN:arg6", classID)

	local colortmp = RAID_CLASS_COLORS[classFileName]
	color = { colortmp.r, colortmp.g, colortmp.b }
	local _, _, icon = GetSpellInfo(cooldown['spellID'])
	bar:SetIcon(icon)
	
	bar:SetColor(color)
	bar:SetDuration(duration)
	bar:SetLabelFont(v.media.font, 16)
	bar:SetDurationFont(v.media.font, 16)

	if group == SN.F.debuffs then
		bar:SetLabel(spell)
	else
		bar:SetLabel(caster.."       "..spell)
	end
	bar.TimeSinceLastUpdate = 0
	--bar.RegisterCallback(self, "FancyBar_BarStop", "CleanUpBars")
	bar:SetScript("OnEvent", function(self, event, ...)
		if event == "COMBAT_LOG_EVENT_UNFILTERED" then
			local _, type, _, _, sourceName, _, _, destGUID, destname, _, _ = ...
			local spellId, spellName, spellSchool = select(12, ...)
			
			if type == "UNIT_DIED" then
				if destGUID == self:GetData("SN:arg3") then
					self:Stop()
				end
			end
			if type == "SPELL_CAST_SUCCESS" then
				if select(2, UnitClass("player")) == "HUNTER" then
					if spellId == 23989 then
						local cdtmp = self:GetData("SN:arg2")
						if cdtmp['reset'] == true then
							self:Stop()
						end
					end
				end
			end
		end	
	end)
	group:Add(bar)
	bar:Start()
	
end

function SN:AnnounceCD(cooldown, caster)

	if (SN.V.defaults.profile.CD.castannounce) and (SN.V.defaults.profile.CD.raid) and (UnitIsGroupLeader("player")) then
		
		local dur = cooldown['CD'] / 60
		local class, classFileName, classID = UnitClass(caster)
		
		if GetNumGroupMembers() > 1 and IsInRaid() then
			SendChatMessage(caster.." casts "..GetSpellLink(cooldown['spellID']).." "..dur.."min".." CD", "RAID")
		elseif GetNumGroupMembers() > 1 and not IsInRaid() then
			SendChatMessage(caster.." casts "..GetSpellLink(cooldown['spellID']).." "..dur.."min".." CD", "PARTY")
		else
			SendChatMessage(caster.." casts "..GetSpellLink(cooldown['spellID']).." "..dur.."min".." CD", "SAY")
		end
	end
end