-- Cooldown Module

local width, height = 300, 28

function SN:CoolDowns()
	
	SN.F.cooldowns = SN.timers:NewGroup(width, "CDGroup", cdowngrp)
	SN.F.cooldowns:SetSpacing(0, 7)
	SN.F.cooldowns:SetSorting("SN:arg4")
	if(IsAddOnLoaded("ElvUI")) then
		SN.F.cooldowns:SetSpacing(0, 7)
		SN.F.cooldowns:SetStartPoint("bottomleft")
		SN.F.cooldowns:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 5, 0)
	else
		SN.F.cooldowns:SetSpacing(0, 3)
		SN.F.cooldowns:SetStartPoint("topleft")
		SN.F.cooldowns:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -100, 0)
	end
	SN.F.cooldowns:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	SN.F.cooldowns:SetScript("OnEvent", function(self, event, unit, ...)
		SN:UpdateCooldown(self, event, unit, ...)
	end)
	SN.F.cooldowns:Lock(SN.V.defaults.profile.Frames.lock)
end

function SN:UpdateCooldown(group, event, unit, ...)

	if event == "COMBAT_LOG_EVENT_UNFILTERED" then

		local type, _, sourceGUID, sourceName,_,_, destGUID, destName =  ...
		local spellId, spellName, spellSchool = select(11, ...)

		for i, cooldown in pairs(SN.cooldowns) do
			if type == cooldown['succ'] then
				if spellId == cooldown['spellID'] then
					if SN.V.defaults.profile.CD.justyou == true and cooldown['type'] == "personal" then
						if sourceGUID == UnitGUID("player") then
							local cast = select(7, GetSpellInfo(spellId))
							cast = cast * 0.001
							if cast > 0 then
								args = { group, cooldown, cooldown['CD'], sourceName, sourceGUID, spellName }
								SN:ScheduleTimer("StartCastDelay", cast, args)
							else
								SN:CreateBar(group, cooldown, cooldown['CD'], sourceName, sourceGUID, spellName)
							end
						end
					elseif SN.V.defaults.profile.CD.raid == true and cooldown['type'] == "raid" then
						if UnitInParty(sourceName) or UnitInRaid(sourceName) or (sourceGUID == UnitGUID("player")) then
							local cast = select(7, GetSpellInfo(spellId))
							cast = cast * 0.001
							if cast > 0 then
								args = { group, cooldown, cooldown['CD'], sourceName, sourceGUID, spellName }
								SN:ScheduleTimer("StartCastDelay", cast, args)
							else
								SN:CreateBar(group, cooldown, cooldown['CD'], sourceName, sourceGUID, spellName)
							end
						SN:AnnounceCD(cooldown, sourceName)
						end
					end
				end
			end
		end
	end
end

function SN:StartCastDelay(args)
	SN:CreateBar(args[1], args[2], args[3], args[4], args[5], args[6])
end
